//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%47F129F900E6.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%47F129F900E6.cm

//## begin module%47F129F900E6.cp preserve=no
//## end module%47F129F900E6.cp

//## Module: MathExpression%47F129F900E6; Package specification
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Parse/MathExpression.h

#ifndef MATHEXPRESSION_H
#define MATHEXPRESSION_H 1

//## begin module%47F129F900E6.additionalIncludes preserve=no
//## end module%47F129F900E6.additionalIncludes

//## begin module%47F129F900E6.includes preserve=yes
//## end module%47F129F900E6.includes

// AbstractExpression
#include <XSUtil/Parse/AbstractExpression.h>
// Error
#include <XSUtil/Error/Error.h>
//## begin module%47F129F900E6.declarations preserve=no
//## end module%47F129F900E6.declarations

//## begin module%47F129F900E6.additionalDeclarations preserve=yes
namespace Numerics {
   class MathOperator;
}
//## end module%47F129F900E6.additionalDeclarations


//## begin MathExpression%47F12AE3021B.preface preserve=yes
//## end MathExpression%47F12AE3021B.preface

//## Class: MathExpression%47F12AE3021B
//	Concrete subclass of AbstractExpression.  This parses
//	and evaluates general mathematical expressions, used by
//	Xspec's mdefine command.
//## Category: XSUtil::Parse%36939CA6F48B
//## Subsystem: XSUtil::Parse%3E8C4EAA02A6
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class MathExpression : public AbstractExpression  //## Inherits: <unnamed>%47F12AF502CF
{
  //## begin MathExpression%47F12AE3021B.initialDeclarations preserve=yes
  //## end MathExpression%47F12AE3021B.initialDeclarations

  public:
    //## Class: MathExpressionError%47F29842002B
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class MathExpressionError : public YellowAlert  //## Inherits: <unnamed>%47F298660166
    {
      public:
        //## Constructors (specified)
          //## Operation: MathExpressionError%47F298CB0187
          MathExpressionError (const string& errMsg);

      protected:
      private:
      private: //## implementation
    };

  private:
    //## Class: MathOpContainer%4805151C001C; private
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::map<string,Numerics::MathOperator*> MathOpContainer;

    //## begin MathExpression::ElementType%47F295CC034D.preface preserve=yes
    //## end MathExpression::ElementType%47F295CC034D.preface

    //## Class: ElementType%47F295CC034D; private
    //## Category: XSUtil::Parse%36939CA6F48B
    //## Subsystem: XSUtil::Parse%3E8C4EAA02A6
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {ENG, ENGC, NUM, PARAM, OPER, UFUNC, BFUNC, LPAREN, RPAREN, COMMA} ElementType;

    //## begin MathExpression::ElementType%47F295CC034D.postscript preserve=yes
    //## end MathExpression::ElementType%47F295CC034D.postscript

  public:
    //## Constructors (generated)
      MathExpression(const MathExpression &right);

    //## Constructors (specified)
      //## Operation: MathExpression%4820C2E5029A
      MathExpression (std::pair<Real,Real> eLimits, const string& compType);

    //## Destructor (generated)
      virtual ~MathExpression();

    //## Assignment Operation (generated)
      MathExpression & operator=(const MathExpression &right);


    //## Other Operations (specified)
      //## Operation: init%4815F8E3022D
      virtual void init (const string& exprString, bool removeWhitespace = true);

      //## Operation: clone%47F1339103CB
      virtual MathExpression* clone () const;

      //## Operation: clearOperatorsMap%47F27859012C
      static void clearOperatorsMap ();

      //## Operation: evaluate%48078430013C
      void evaluate (const RealArray& energies, const RealArray& parameters, RealArray& flux, RealArray& fluxErr) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: distinctParNames%47F2931F00DC
      //	This will be the size of number of unique parameter
      //	names found in the expression.  The names will be stored
      //	in order of first left-to-right appearance, and should
      //	be the same order as the user prompts, and the order of
      //	the parameter values array sent to the evaluate function.
      const std::vector<string>& distinctParNames () const;

      //## Attribute: eLow%4820C31E02D7
      Real eLow () const;
      void eLow (Real value);

      //## Attribute: eHigh%4820C3590257
      Real eHigh () const;
      void eHigh (Real value);

    // Additional Public Declarations
      //## begin MathExpression%47F12AE3021B.public preserve=yes
      //## end MathExpression%47F12AE3021B.public

  protected:

    //## Other Operations (specified)
      //## Operation: Swap%47F13248009A
      void Swap (MathExpression& right);

    // Additional Protected Declarations
      //## begin MathExpression%47F12AE3021B.protected preserve=yes
      //## end MathExpression%47F12AE3021B.protected

  private:

    //## Other Operations (specified)
      //## Operation: allValidChars%47F13962021E
      virtual const string& allValidChars () const;

      //## Operation: buildOperatorsMap%47F27831010E
      static void buildOperatorsMap ();

      //## Operation: convertToInfix%47F297FF0236
      void convertToInfix ();

      //## Operation: convertToPostfix%47FFA29A0104
      void convertToPostfix ();

      //## Operation: classifyWords%4804EC7F0380
      MathExpression::ElementType classifyWords (const string& wordStr);

      //## Operation: verifyInfix%480517F5025F
      void verifyInfix () const;

      //## Operation: verifyBFunc%48062DCC0135
      //	Internal recursive function for validating commas in
      //	binary function calls.
      void verifyBFunc (size_t* idxElem) const;

      //## Operation: convolveEvaluate%4890DA700091
      void convolveEvaluate (const RealArray& energies, const RealArray& parameters, RealArray& flux, RealArray& fluxErr) const;

    // Additional Private Declarations
      //## begin MathExpression%47F12AE3021B.private preserve=yes
      //## end MathExpression%47F12AE3021B.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: allValidChars%47F139D7032D
      //## begin MathExpression::allValidChars%47F139D7032D.attr preserve=no  private: static string {UC} string("_#,.+-/*^()abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 \t\r\n")
      static const string s_allValidChars;
      //## end MathExpression::allValidChars%47F139D7032D.attr

      //## Attribute: operatorsMap%47F1559E0027
      //## begin MathExpression::operatorsMap%47F1559E0027.attr preserve=no  private: static MathExpression::MathOpContainer {U} 
      static MathExpression::MathOpContainer s_operatorsMap;
      //## end MathExpression::operatorsMap%47F1559E0027.attr

      //## Attribute: precedenceMap%48065A3E0129
      //## begin MathExpression::precedenceMap%48065A3E0129.attr preserve=no  private: static std::map<string,int> {U} 
      static std::map<string,int> s_precedenceMap;
      //## end MathExpression::precedenceMap%48065A3E0129.attr

      //## begin MathExpression::distinctParNames%47F2931F00DC.attr preserve=no  public: std::vector<string> {U} 
      std::vector<string> m_distinctParNames;
      //## end MathExpression::distinctParNames%47F2931F00DC.attr

      //## Attribute: paramsToGet%48078B6D0164
      //	Maintains an index for each appearance of a PARAM in
      //	expression, in left-to-right order.  The index refers to
      //	which element of the user's input parameter array, and
      //	is equivalent to the ordering in the distinctParNames
      //	array.
      //## begin MathExpression::paramsToGet%48078B6D0164.attr preserve=no  private: std::vector<size_t> {U} 
      std::vector<size_t> m_paramsToGet;
      //## end MathExpression::paramsToGet%48078B6D0164.attr

      //## Attribute: numericalConsts%47F294F80070
      //## begin MathExpression::numericalConsts%47F294F80070.attr preserve=no  private: std::vector<Real> {U} 
      std::vector<Real> m_numericalConsts;
      //## end MathExpression::numericalConsts%47F294F80070.attr

      //## Attribute: mathOperators%4804EB9A029C
      //	This holds iterators to ALL mathematical operators, both
      //	the built-in kind and function calls.  It is originally
      //	filled in infix order, then re-arranged to postfix order
      //	before object construction is complete.
      //## begin MathExpression::mathOperators%4804EB9A029C.attr preserve=no  private: std::vector<MathExpression::MathOpContainer::const_iterator> {U} 
      std::vector<MathExpression::MathOpContainer::const_iterator> m_mathOperators;
      //## end MathExpression::mathOperators%4804EB9A029C.attr

      //## Attribute: postfixElems%47F3B740009B
      //## begin MathExpression::postfixElems%47F3B740009B.attr preserve=no  private: std::vector<MathExpression::ElementType> {U} 
      std::vector<MathExpression::ElementType> m_postfixElems;
      //## end MathExpression::postfixElems%47F3B740009B.attr

      //## Attribute: infixElems%47FFA8A60394
      //## begin MathExpression::infixElems%47FFA8A60394.attr preserve=no  private: std::vector<MathExpression::ElementType> {U} 
      std::vector<MathExpression::ElementType> m_infixElems;
      //## end MathExpression::infixElems%47FFA8A60394.attr

      //## begin MathExpression::eLow%4820C31E02D7.attr preserve=no  public: Real {U} 
      Real m_eLow;
      //## end MathExpression::eLow%4820C31E02D7.attr

      //## begin MathExpression::eHigh%4820C3590257.attr preserve=no  public: Real {U} 
      Real m_eHigh;
      //## end MathExpression::eHigh%4820C3590257.attr

      //## Attribute: compType%499C773002F4
      //## begin MathExpression::compType%499C773002F4.attr preserve=no  private: string {U} 
      string m_compType;
      //## end MathExpression::compType%499C773002F4.attr

    // Additional Implementation Declarations
      //## begin MathExpression%47F12AE3021B.implementation preserve=yes
      //## end MathExpression%47F12AE3021B.implementation

};

//## begin MathExpression%47F12AE3021B.postscript preserve=yes
//## end MathExpression%47F12AE3021B.postscript

// Class MathExpression::MathExpressionError 

// Class MathExpression 

//## Get and Set Operations for Class Attributes (inline)

inline const std::vector<string>& MathExpression::distinctParNames () const
{
  //## begin MathExpression::distinctParNames%47F2931F00DC.get preserve=no
  return m_distinctParNames;
  //## end MathExpression::distinctParNames%47F2931F00DC.get
}

inline Real MathExpression::eLow () const
{
  //## begin MathExpression::eLow%4820C31E02D7.get preserve=no
  return m_eLow;
  //## end MathExpression::eLow%4820C31E02D7.get
}

inline void MathExpression::eLow (Real value)
{
  //## begin MathExpression::eLow%4820C31E02D7.set preserve=no
  m_eLow = value;
  //## end MathExpression::eLow%4820C31E02D7.set
}

inline Real MathExpression::eHigh () const
{
  //## begin MathExpression::eHigh%4820C3590257.get preserve=no
  return m_eHigh;
  //## end MathExpression::eHigh%4820C3590257.get
}

inline void MathExpression::eHigh (Real value)
{
  //## begin MathExpression::eHigh%4820C3590257.set preserve=no
  m_eHigh = value;
  //## end MathExpression::eHigh%4820C3590257.set
}

//## begin module%47F129F900E6.epilog preserve=yes
//## end module%47F129F900E6.epilog


#endif
